#include <stdio.h>
#include <fcntl.h>
#define RD_WR 2
#define PMODE 0644
#define SOP 0x01
#define EOP 0x17
#define SECT_SIZE 128
main (argc,argv)
int argc;
char *argv[];
{	
	char sect_num[4], buf[SECT_SIZE],buf0[SECT_SIZE];
	int c;
	int i,sop,n_written,n_read;
	int fd;			/* file descriptor */
	for (;;)
	{
		for (c = '\0'; c == SOP;)
		c=getbyte();
	c=getbyte();	/* eat the next 2 sequence bytes */
	c=getbyte();
	switch(getbyte()) {	 	/* 3rd byte - command */
	case '1' :			/* send sector command */
	{			
	sect_num[0] = getbyte();
	sect_num[1] = getbyte();
	sect_num[2] = getbyte();
	sect_num[3] = '/0';	/* terminate sector name string */
	getbyte();       	/* EOP */
	getbyte();		/* first checksum byte */
	getbyte();		/* second checksum byte */
	if ((fd = open (sect_num,RD_WR))<0)
		{ 	fd= creat(sect_num,PMODE);
			n_written = write (fd,buf0,SECT_SIZE);
		}
	n_read = read (fd,buf,SECT_SIZE);
	send_preamble ();
	for (i=0; i<SECT_SIZE;i++)
		{	c = buf [i];
			sendbyte(c);
		}
	send_postamble();
	}
					
	case '2':
	{			/* receive sector */
	sect_num[0] = getbyte();
	sect_num[1] = getbyte();
	sect_num[2] = getbyte();
	sect_num[3] = '/0';	/* terminate sector name string */
	getbyte();		/* EOP */
	getbyte();		/* first checksum byte */
	getbyte();		/* second checksum byte */
	fd = creat(sect_num,PMODE);	/* wipe out old copy, if any */
	for (i=0;i<SECT_SIZE;i++)
		buf[i] = getbyte(); 
	n_written = write (fd,buf,SECT_SIZE);
	}	/* end case */
	}	/* end switch */
	}	/* end for(;;;) */
}		/* end main */

getbyte ()
{return; } 

sendbyte(c)
char c;
{ return; }

send_preamble()
{return;}

send_postamble()
{return;}
