#include <stdio.h>
#include <fcntl.h>
#define OUT_LENGTH 1
main (argc,argv)
int argc;
char *argv[];

{
	FILE *fpin, *fopen();
	int out_nfile;	/*file number or error code */
	int out_status;
	int out_length;
	char *out_byte;
	int mode ;		/* mode read,write, r/w etc.*/
	int n,c;
	int  hexhi, hexlo;
	if (argc<3)
	{
	fprintf (stderr,"type %s  <input fn>  <output fn> \n",*argv);
		 exit (1);
	}
	if ((fpin=fopen(*++argv,"r"))==NULL)
		{
		fprintf (stderr,"Error opening input file %s \n",*argv);
		exit (2);
		}
	mode = O_WRONLY | O_RAW | O_CREAT;
	if ((out_nfile=open(*++argv,mode))==-1)
	{
	fprintf (stderr,"Error creating output file %s\n",*argv);
	exit(3);
	}
	out_length=OUT_LENGTH;
	for (;;)	/* infinite loop*/
	{
	if ((c=getc(fpin))==EOF)
		break;
	if (c>='A'&& c<='F')
		hexhi=c-'A'+10;
	else if (c>='0' && c<='9')
		hexhi=c-'0';
	else
	{
		printf ("input file not a hex file !!!");
		break;
	}
	if ((c=getc(fpin))==EOF)
		break;
	if (c>='A'&& c<='F')
		hexlo=c-'A'+10;
	else if (c>='0' && c<='9')
		hexlo=c-'0';
	else
	{
		printf ("input file not a hex file !!!");
		break;
	}
	*out_byte=hexlo+(16*hexhi);
	if((out_status=write(out_nfile,out_byte,out_length))<OUT_LENGTH)
	{
		printf("error writing to output file \n");
		break;
	}
	}	/* for infinite loop*/
	close(out_nfile);
	fclose(fpin);
}
