#include <stdio.h>
#include <fcntl.h>
#define IN_LENGTH 512
main (argc,argv)
int argc;
char *argv[];

{
	FILE *fpout, *fopen();
	int in_nfile;	/*file number or error code */
	int in_status;
	int in_length;
	char in_buffer[IN_LENGTH];
	int mode ;		/* mode read,write, r/w etc.*/
	int n,c, hexhi, hexlo;
	if (argc<3)
	{
	fprintf (stderr,"type %s  <input fn>  <output fn> \n",*argv);
		 exit (1);
	}
	mode = O_RDONLY | O_RAW ;
	if ((in_nfile=open(*++argv,mode))==-1)
	{
		fprintf (stderr,"Error opening input file %s \n",*argv);
		exit (2);
	}
	if ((fpout=fopen(*++argv,"w"))==NULL)
	{
	fprintf (stderr,"Error creating output file %s\n",*argv);
	exit(3);
	}
	in_length=IN_LENGTH;
	while  ((in_status=read(in_nfile,in_buffer,in_length)) > 0)
	{
		for (n=0; n<in_status; ++n)
		{
		c=in_buffer[n];
		bin2hex(&c,&hexlo,&hexhi);
		putc(hexhi,fpout);
		putc(hexlo,fpout);
		}
	}
	close(in_nfile);
	fclose(fpout);
}




bin2hex(nc,nhexlo,nhexhi)

int *nc,*nhexlo, *nhexhi;

{
	unsigned n;
	n=*nc&0x0f; 	/* mask off upper nibble */
	if (n<=9)
		*nhexlo = n+'0';
	else
		*nhexlo = n-10+'A';
	n=*nc;
	n=(n>>4)&0x0f;
	if (n<=9)
		*nhexhi = n+'0';
	else
		*nhexhi = n-10+'A';
}