#define IBMPC 1
#include <stdio.h>
#include <fcntl.h>
#include <dos.h>
union REGS inregs;
union REGS outregs;
struct SREGS segregs;
struct	rs232_init_parms {
	unsigned word_length : 2 ;
	unsigned stopbit : 1 ;
	unsigned parity : 2 ;
	unsigned baud_rate : 3 ;
} com_init_parm ;

main (argc,argv)
{
int ret;
int c,hit;
int intno ; /* interrupt number */

/*intitialize COM2: 9600 baud,1 stop bit,8 data bits,no parity  */
	com_init_parm.baud_rate = 07 ; 	/* 9600 baud */
	com_init_parm.parity = 0	;	/* no parity */
	com_init_parm.stopbit = 0	; /* 1 stop bit */
	com_init_parm.word_length = 03 ; /* 8 bits */

	inregs.h.al = 227 ;
	inregs.h.ah = 0 ; /* command to initialize */
	inregs.x.dx = 1 ;	/* for COM1: */
	intno = 0x14 ; /* RS_232 i/o int 14 */
	ret = int86 (intno,&inregs,&outregs);
	printf ("Initialized : %4x %4x",inregs.x.ax,inregs.h.al);

/* now set up to emulate TTY	*/
	for (;;)	{
		while((hit = kbhit ())== 0)
		 ; 		/* wait until char on keyboard */
		c=getch();
		inregs.h.al = c	;/* put char in al */
		inregs.h.ah = 0x1 ;	/* INT 14 command to send char */
		ret = int86 (intno,&inregs,&outregs);
	printf ("Char sent : %4x %4x",inregs.x.ax,inregs.h.al);
		inregs.h.ah = 0;
		while (inregs.h.ah == 0)	{
		inregs.h.ah = 0x2 ; /* INT 14 command to receive*/ 
		ret = int86 (intno,&inregs,&outregs);
	printf ("Char rcvd : %4x %4x",inregs.x.ax,inregs.h.al);
		c=inregs.h.al; 
		putch(c);	/*echo on console */
		}
	}
}