          TITLE     TEST
          SUBTTL    EQUATE
          PAGE      +
EOF       EQU       00H
OPENF     EQU       0FH
CLOSEF    EQU       10H
DELETEF   EQU       13H
READF     EQU       14H
WRITEF    EQU       15H
SETDTA    EQU       1AH
DISPLAYC  EQU       02H
PRINTC    EQU       05H
INPUTC    EQU       08H
          SUBTTL    MACRO
          PAGE      +
DOSCALL   MACRO     FUNCTION
          MOV       AH,FUNCTION
          INT       21H
          ENDM
SAVEREG   MACRO
          PUSH      DS
          SUB       AX,AX
          PUSH      AX
          MOV       AX,DSEG
          MOV       DS,AX
          ENDM
FCB       STRUC
drive     DB        00H
filename  DB        'TEST    '
fileext   DB        'ASM'
curblock  DB        02 DUP(?)
recsize   DB        02 DUP(?)
filesize  DB        04 DUP(?)
filedate  DB        02 DUP(?)
reserved  DB        10 DUP(?)
seqrecno  DB        00H
ranrecno  DB        04 DUP(?)
FCB       ENDS
          SUBTTL    STACK
          PAGE      +
SSEG      SEGMENT   PARA STACK 'STACK'
          DB        64 DUP('STACK   ')
SSEG      ENDS
          SUBTTL    DATA
          PAGE      +
DSEG      SEGMENT   PARA PUBLIC 'DATA'
          FCB       <>
BUFFER    DB        128 DUP(?)
DSEG      ENDS
          SUBTTL    CODE
          PAGE      +
CSEG      SEGMENT   PARA PUBLIC 'CODE'
          ASSUME    CS:CSEG,DS:DSEG,SS:SSEG
TEST      PROC      FAR
          SAVEREG
          MOV       DX,OFFSET FCB
          DOSCALL   OPENF
          CMP       AL,00H
          JNZ       exitt
          MOV       DX,OFFSET BUFFER
          DOSCALL   SETDTA
loopt:    MOV       DX,OFFSET FCB
          DOSCALL   READF
          CALL      PRINT
          CMP       BX,128
          JE        loopt
          MOV       DX,OFFSET FCB
          DOSCALL   DELETEF
exitt:    RET
TEST      ENDP
          PAGE      +
PRINT     PROC      NEAR
          SUB       BX,BX
loopp:    MOV       DL,BUFFER[BX]
          CMP       DL,EOF
          JE        exitp
          DOSCALL   PRINTC
          INC       BX
          CMP       BX,128
          JL        loopp
exitp:    RET
PRINT     ENDP
CSEG      ENDS
          END       TEST
