#include <stdio.h>
#include <fcntl.h>
#define IN_LENGTH 1024
#define OUT_LENGTH IN_LENGTH/2
main (argc,argv)
int argc;
char *argv[];
{
	int in_nfile,out_nfile;	/*file number or error code */
	int in_status,out_status;
	int in_length,out_length;
	char in_buffer[IN_LENGTH],out_buffer[OUT_LENGTH];
	int in_mode,out_mode ;		/* mode read,write, r/w etc.*/
	int m,n;
	int  hexhi, hexlo;
	if (argc<3)
	{
	fprintf (stderr,"type %s  <input fn>  <output fn> \n",argv[0]);
		 exit (1);
	}
	in_mode=O_RDONLY;
	if ((in_nfile=open(*++argv,in_mode))==-1)
		{
		fprintf (stderr,"Error opening input file %s \n",*argv);
		exit (2);
		}
	out_mode = O_WRONLY | O_RAW | O_CREAT;
	if ((out_nfile=open(*++argv,out_mode))==-1)
	{
	fprintf (stderr,"Error creating output file %s\n",*argv);
	exit(3);
	}
	in_length=IN_LENGTH;
	while ((in_status=read(in_nfile,in_buffer,in_length))>0)
	{
	for (n=0,m=0;m<in_status/2;++m)	
	{
	if (in_buffer[n]>='A'&& in_buffer[n]<='F')
		hexhi=in_buffer[n]-'A'+10;
	else if (in_buffer[n]>='0' && in_buffer[n]<='9')
		hexhi=in_buffer[n]-'0';
	else
	{
		fprintf (stderr,"input file not a hex file !!!");
		break;
	}
	n++;
	if (in_buffer[n]>='A'&& in_buffer[n]<='F')
		hexlo=in_buffer[n]-'A'+10;
	else if (in_buffer[n]>='0' && in_buffer[n]<='9')
		hexlo=in_buffer[n]-'0';
	else
	{
		fprintf (stderr,"input file not a hex file !!!");
		break;
	}
	n++;
	out_buffer[m]=hexlo+(16*hexhi);
	}	/* for loop */
	out_length=m;
	if((out_status=write(out_nfile,out_buffer,out_length))<out_length)
	{
		printf("error writing to output file \n");
		break;
	}
	}	/* while loop*/
	close(out_nfile);
	close(in_nfile);
}
